﻿;;;===============================================================================
;;;13/11/21
;;;                    ARIBERTO-TASKS
;;;             Copyright Marcio@UTC, 2013
;;;
;;;=============================================================================== 

#|
The current file is its task library. It contains a model of all tasks the agent
can execute, related to questions asked to projects.
  
Questions on projects or theses:
   - quels sont les projets en cours d'ASER ?
   - quels sont les projets en cours avec le japon ?
TASKS:
   - GETTING PROJECTS (_get-project-conversation)
 
2013
 1121 used shared-task from HDSRI project as a source for the sample creation (MFK)
 |#

(format t "~&loading ARIBERTO TASKS, package is: ~S" *package*)

;;;=============================================================================== 
;;;   
;;;                               TASK MODEL
;;;
;;;===============================================================================

;;; The task model is used in programming mode (following a web request) or
;;; interaction mode through the assistant window. In practice however, the 
;;; interaction mode is used for debugging or control rather than normal operations.

(defconcept (:en "task index")
  (:doc :en "A TASK INDEX is a property of a task. The index attribute specifies ~
             the term being used, the weight attribute gives its importance for the ~
             task.")
  (:att (:en "index"))
  (:att (:en "weight"))
  )

(definstmethod =summary TASK-INDEX ()
  (list (format nil "~A ~S" (car(has-index))(has-weight))))

(defconcept (:en "task")
  (:is-a moss::$QTSKE) ; used for linking inheritage ?
  (:doc :en "A TASK is a model of task to be performed by the assistant.")
  (:att (:en "task name") (:unique)(:entry))
  (:att (:en "dialog"))
  (:att (:en "where to ask")) ; e.g. :ADDRESS
  (:att (:en "fail question"))
  (:rel (:en "index pattern")(:to "task index"))
  (:att (:en "performative") (:id $PRFT)(:one-of :request :assert :command :answer))
  (:att (:en "message action")) ; e.g. :get-address
  )

(definstmethod =summary TASK ()
  (HAS-TASK-NAME))
 
;;;=============================================================================== 
;;;   
;;;                               TASK LIBRARY
;;;
;;;=============================================================================== 

;;;============================================================== GETTING PROJECTS

(deftask "get project"
  :doc "Tâche permettant d'obtenir une liste de projets"
  :dialog _get-project-conversation
  :indexes ("projets de" .35 "projet" .35 "projets" .35 "en cours" .2)
  )

;;;=============================================================================== 
(format t "~%;*** MOSS v~A - SHARED TASKS loaded ***" moss::*moss-version-number*)

:EOF
:EOF